/* rgbaautocrop 1/3/97 Monty */

#define R(x) (((x)>>16)&0xffL)
#define G(x) (((x)>>8)&0xffL)
#define B(x) ((x)&0xffL)

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <malloc.h>

int main(int argc,char *argv[]){
  FILE *outfile=stdout;
  FILE *infile=stdin;
  int i=1,x,y;
  char test[8];

  /* First arg could be a filename */

  if(argc>1){
    infile=fopen(argv[i],"rb");
    if(infile==NULL){
      fprintf(stderr,"rgbaautocrop: Unable to open input file.\n");
      exit(-1);
    }
    i++;
  }

  fscanf(infile,"%7c",test);
  test[7]='\0';
  if(strcmp(test,"RGBA32 ")){
    fprintf(stderr,"rgbaautocrop: input is not an RGBA32 file.\n");
    exit(-1);
  }
  
  fscanf(infile,"%d %d%*1c",&x,&y);

  {
    int xi,yi;
    long *c,*a;
    long *cP,*aP;
    int ptr;
    int x1=x,x2=0,y1=y,y2=0,backgrnd;

    c=cP=malloc(x*y*sizeof(long));
    a=aP=malloc(x*y*sizeof(long));

    for(yi=0;yi<y;yi++){
      ptr=x*yi;
      for(xi=0;xi<x;xi++){
	c[ptr]=((unsigned char)fgetc(infile))<<16;
	c[ptr]+=((unsigned char)fgetc(infile))<<8;
	c[ptr]+=(unsigned char)fgetc(infile);
	a[ptr]=(unsigned char)fgetc(infile);
	ptr++;
      }
    }

    backgrnd=c[0];

    for(yi=0;yi<y;yi++){
      ptr=x*yi;
      for(xi=0;xi<x;xi++){
	if(c[ptr++]!=backgrnd){
	  if(xi<x1)x1=xi;
	  if(yi<y1)y1=yi;
	  if(xi>=x2)x2=xi+1;
	  if(yi>=y2)y2=yi+1;
	}
      }
    }


    fprintf(outfile,"RGBA32 %d %d\n",x2-x1,y2-y1);

    for(yi=y1;yi<y2;yi++){
      c=cP+yi*x;
      a=aP+yi*x;
      for(xi=x1;xi<x2;xi++){
	fprintf(outfile,"%c%c%c%c",(unsigned char)R(c[xi]),
		(unsigned char)G(c[xi]),
	        (unsigned char)B(c[xi]),
		(unsigned char)a[xi]);
	  
      }
    }
  }
  fclose(infile);
  fclose(outfile);
  return(0);
}    






